"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _reactBeautifulDnd = require("react-beautiful-dnd");

var _uniqueId = require("lodash/uniqueId");

var _uniqueId2 = _interopRequireDefault(_uniqueId);

var _get = require("lodash/get");

var _get2 = _interopRequireDefault(_get);

var _button = require("@atlaskit/button");

var _button2 = _interopRequireDefault(_button);

var _reactFormsProcessor = require("react-forms-processor");

var _Expander = require("../../atlaskit/src/components/Expander");

var _Expander2 = _interopRequireDefault(_Expander);

var _form = require("@atlaskit/form");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var createFormForItem = function createFormForItem(item, targetIndex, fieldsForForm, formChangeHandler) {
  var mappedFields = fieldsForForm.map(function (field) {
    return _extends({}, field, {
      id: field.id + "_" + targetIndex + "_FIELDS"
    });
  });
  return _react2.default.createElement(
    _reactFormsProcessor.FormContext.Consumer,
    null,
    function (context) {
      var renderer = context.renderer,
          optionsHandler = context.optionsHandler,
          validationHandler = context.validationHandler;

      return _react2.default.createElement(_reactFormsProcessor.Form, {
        parentContext: context,
        key: "FIELD_" + targetIndex,
        defaultFields: mappedFields,
        renderer: renderer,
        value: item,
        optionsHandler: optionsHandler,
        validationHandler: validationHandler,
        onChange: formChangeHandler
      });
    }
  );
};

var reorder = function reorder(list, startIndex, endIndex) {
  var result = Array.from(list);

  var _result$splice = result.splice(startIndex, 1),
      _result$splice2 = _slicedToArray(_result$splice, 1),
      removed = _result$splice2[0];

  result.splice(endIndex, 0, removed);

  return result;
};

var grid = 8;

var getListStyle = function getListStyle(isDraggingOver) {
  return {
    background: isDraggingOver ? "lightblue" : "lightgrey"
  };
};

var getItemStyle = function getItemStyle(isDragging, draggableStyle) {
  return _extends({
    // some basic styles to make the items look a bit nicer
    userSelect: "none",
    padding: grid * 2,

    // change background colour if dragging
    background: isDragging ? "lightgreen" : "white"

  }, draggableStyle);
};

var Repeats = function (_Component) {
  _inherits(Repeats, _Component);

  function Repeats(props) {
    _classCallCheck(this, Repeats);

    var _this = _possibleConstructorReturn(this, (Repeats.__proto__ || Object.getPrototypeOf(Repeats)).call(this, props));

    var fields = props.fields,
        _props$defaultValue = props.defaultValue,
        defaultValue = _props$defaultValue === undefined ? [] : _props$defaultValue,
        onChange = props.onChange;

    // Map the supplied array to an Item[] in order to give each piece of data an id for drag-and-drop

    var items = defaultValue.map(function (data) {
      return { id: (0, _uniqueId2.default)(), data: data };
    });
    _this.state = {
      value: defaultValue,
      items: items
    };
    return _this;
  }

  _createClass(Repeats, [{
    key: "addItem",
    value: function addItem() {
      var items = this.state.items;

      items = [].concat(_toConsumableArray(items), [{ id: (0, _uniqueId2.default)(), data: {} }]);
      // this.updateItemState(items);
      this.setState({
        items: items
      });
    }
  }, {
    key: "removeItem",
    value: function removeItem(id) {
      var items = this.state.items;

      items = items.filter(function (item) {
        return item.id !== id;
      });
      this.updateItemState(items);
    }
  }, {
    key: "createFormChangeHandler",
    value: function createFormChangeHandler(index) {
      var _this2 = this;

      return function (value, isValid) {
        var items = _this2.state.items;

        items[index].data = value;
        _this2.updateItemState(items);
      };
    }
  }, {
    key: "updateItemState",
    value: function updateItemState(items) {
      var _this3 = this;

      this.setState({
        items: items
      }, function () {
        var onChange = _this3.props.onChange;
        var items = _this3.state.items;

        var value = items.map(function (item) {
          return item.data;
        });
        onChange && onChange(value);
      });
    }
  }, {
    key: "onDragEnd",
    value: function onDragEnd(result) {
      // dropped outside the list
      if (!result.destination) {
        return;
      }

      var items = reorder(this.state.items, result.source.index, result.destination.index);

      this.updateItemState(items);
    }
  }, {
    key: "getForms",
    value: function getForms() {
      var _this4 = this;

      var items = this.state.items;
      var _props = this.props,
          fields = _props.fields,
          _props$idAttribute = _props.idAttribute,
          idAttribute = _props$idAttribute === undefined ? "id" : _props$idAttribute,
          _props$label = _props.label,
          label = _props$label === undefined ? "Item" : _props$label,
          onChange = _props.onChange,
          _props$unidentifiedLa = _props.unidentifiedLabel,
          unidentifiedLabel = _props$unidentifiedLa === undefined ? "Unidentified item" : _props$unidentifiedLa;


      return _react2.default.createElement(
        _reactBeautifulDnd.DragDropContext,
        { onDragEnd: this.onDragEnd.bind(this) },
        _react2.default.createElement(
          _reactBeautifulDnd.Droppable,
          { droppableId: "droppable" },
          function (provided, snapshot) {
            return _react2.default.createElement(
              "div",
              {
                ref: provided.innerRef,
                style: getListStyle(snapshot.isDraggingOver)
              },
              items.map(function (item, index) {
                var formChangeHandler = _this4.createFormChangeHandler(index);
                var form = createFormForItem(item.data, index, fields, formChangeHandler);
                var label = (0, _get2.default)(item.data, idAttribute, unidentifiedLabel);
                return _react2.default.createElement(
                  _reactBeautifulDnd.Draggable,
                  { key: item.id, draggableId: item.id, index: index },
                  function (provided, snapshot) {
                    return _react2.default.createElement(
                      "div",
                      _extends({
                        ref: provided.innerRef
                      }, provided.draggableProps, provided.dragHandleProps, {
                        style: getItemStyle(snapshot.isDragging, provided.draggableProps.style)
                      }),
                      _react2.default.createElement(
                        _Expander2.default,
                        {
                          key: "exp_" + item.id,
                          label: label,
                          remove: function remove() {
                            _this4.removeItem(item.id);
                          }
                        },
                        form
                      )
                    );
                  }
                );
              }),
              provided.placeholder
            );
          }
        )
      );
    }
  }, {
    key: "render",
    value: function render() {
      var _this5 = this;

      var _props2 = this.props,
          _props2$label = _props2.label,
          label = _props2$label === undefined ? "Item" : _props2$label,
          _props2$addButtonLabe = _props2.addButtonLabel,
          addButtonLabel = _props2$addButtonLabe === undefined ? "Add item" : _props2$addButtonLabe,
          _props2$noItemsMessag = _props2.noItemsMessage,
          noItemsMessage = _props2$noItemsMessag === undefined ? "No items yet" : _props2$noItemsMessag;
      var items = this.state.items;

      var noItems = _react2.default.createElement(
        "span",
        { className: "no-items" },
        noItemsMessage
      );

      return _react2.default.createElement(
        "div",
        null,
        _react2.default.createElement(
          _form.Field,
          { label: label, name: "formBuilder" },
          function () {
            return _react2.default.createElement(
              "div",
              null,
              items.length > 0 ? _this5.getForms() : noItems
            );
          }
        ),
        _react2.default.createElement(
          _button2.default,
          { onClick: function onClick() {
              return _this5.addItem();
            } },
          addButtonLabel
        )
      );
    }
  }]);

  return Repeats;
}(_react.Component);

exports.default = Repeats;