"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _renderer = require("../../atlaskit/src/renderer");

var _renderer2 = _interopRequireDefault(_renderer);

var _FieldDefinitionField = require("./FieldDefinitionField");

var _FieldDefinitionField2 = _interopRequireDefault(_FieldDefinitionField);

var _Repeats = require("./Repeats");

var _Repeats2 = _interopRequireDefault(_Repeats);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var renderer = function renderer(field, _onChange, onFieldFocus, onFieldBlur) {
  var _field$defaultValue = field.defaultValue,
      defaultValue = _field$defaultValue === undefined ? [] : _field$defaultValue,
      id = field.id,
      label = field.label,
      type = field.type,
      _field$misc = field.misc,
      misc = _field$misc === undefined ? {} : _field$misc;

  switch (type) {
    case "field":
      return _react2.default.createElement(_FieldDefinitionField2.default, _extends({ key: id }, field));

    case "repeating":
      var fields = misc.fields || [];
      var addButtonLabel = misc.addButtonLabel;
      var unidentifiedLabel = misc.unidentifiedLabel;
      var noItemsMessage = misc.noItemsMessage;
      var idAttribute = misc.idAttribute;
      return _react2.default.createElement(_Repeats2.default, {
        key: id,
        addButtonLabel: addButtonLabel,
        defaultValue: defaultValue,
        label: label,
        onChange: function onChange(value) {
          return _onChange(id, value);
        },
        fields: fields,
        unidentifiedLabel: unidentifiedLabel,
        noItemsMessage: noItemsMessage,
        idAttribute: idAttribute
      });

    default:
      return (0, _renderer2.default)(field, _onChange, onFieldFocus, onFieldBlur);
  }
};

exports.default = renderer;